/******************************************************************************
*   Project:		DotNetCRM 
*	Filename:		AccountTestFixture.cs
*	Author:			Kristopher Cargile <kris@kriscargile.com>
*	Date Created:	07/03/2008
*******************************************************************************
*	Change History: 
*******************************************************************************
* IMPORTANT GNU LICENSE INFORMATION. DO NOT REMOVE THIS SECTION!
*
* DotNetCRM :: Copyright (c) 2005-2010, Cargile Technology Group, LLC
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
******************************************************************************/

using System.Collections.Generic;
using NUnit.Framework;
using Rhino.Mocks;

namespace DotNetCRM.Core.Tests
{
    [TestFixture]
    public class AccountTests
    {
        [Test]
        public void LoadAccount()
        {
            MockRepository mocks = new MockRepository();

            Account rslt = new Account();
            rslt.Load(1);

            Assert.IsNotNull(rslt);
        }
        
        [Test]
        public void LoadAccountList()
        {
            List<Account> rslt = Account.Load();

            Assert.IsNotNull(rslt);
            Assert.IsNotEmpty(rslt);
        }
    }
}
